﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;

            int X0 = 50, Y0 = 20;
            int SIZE = 40;
            int i;
            float x, y, xx, yy;
            float xx_old = 0F, yy_old = 0F;  //初期値を入れておく
            String string1;

            //グラフを滑らかにする
            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
            //グラフ表示領域をグレイで塗りつぶす
            g.FillRectangle(Brushes.LightGray, X0, Y0, SIZE * 10, SIZE * 10);
            //中心線を描く
            Pen pen1 = new Pen(Color.Black, 2);
            g.DrawLine(pen1, X0, Y0 + 5 * SIZE, X0 + 10 * SIZE, Y0 + 5 * SIZE);  //横
            g.DrawLine(pen1, X0 + 5 * SIZE, Y0, X0 + 5 * SIZE, Y0 + 10 * SIZE);  //縦
            //格子を入れる
            for (i = 0; i <= 10; i++)
            {
                g.DrawLine(Pens.Black, X0, Y0 + i * SIZE, X0 + 10 * SIZE, Y0 + i * SIZE);  //横
                g.DrawLine(Pens.Black, X0 + i * SIZE, Y0, X0 + i * SIZE, Y0 + 10 * SIZE);  //縦
            }
            //目盛を入れる
            for (i = -5; i <= 5; i++)
            {
                string1 = String.Format("{0,3:D}", i);
                g.DrawString(string1, Font, Brushes.Black, X0 - 17 + ((i + 5) * SIZE), Y0 + 13 + 10 * SIZE); //横
                g.DrawString(string1, Font, Brushes.Black, X0 - 30, Y0 - 5 + ((5 - i) * SIZE));          //縦
            }
            //点を打ってグラフを描く
            for (x = -5; x <= 5; x += 0.02F)
            {
                y = x * x + 2 * x - 2;     //グラフに描く二次式
                xx = X0 + (x + 5) * SIZE;  //論理座標から物理座標への変換
                yy = Y0 + (5 - y) * SIZE;  //論理座標から物理座標への変換
                if (y < 5 && y > -5)  //範囲内のみ描く
                {
                    g.FillRectangle(Brushes.Red, xx, yy, 1, 1);
                }
            }
            //線を結んでグラフを描く
            for (x = -5; x <= 5; x += 0.02F)
            {
                y = x * x - 2 * x - 2;     //グラフに描く二次式
                xx = X0 + (x + 5) * SIZE;  //論理座標から物理座標への変換
                yy = Y0 + (5 - y) * SIZE;  //論理座標から物理座標への変換
                if (x != -5 && y < 5 && y > -5)   //最初以外と、範囲内のみ描く
                {
                    g.DrawLine(Pens.Green, xx_old, yy_old, xx, yy);
                }
                xx_old = xx;
                yy_old = yy;
            }
        }
    }
}
